#pragma once

#include "deferable.h"

typedef int (*ComparatorFunc)(void *a, void *b);

DefineDeferable(OrderedUniqueList) {
    Deferable deferable;
    int length;
    int capacity;
    ComparatorFunc comparator;
    Deferable **data;
};

OrderedUniqueList *newOrderedUniqueList(ComparatorFunc comparator);

bool listInsertOrFetch(OrderedUniqueList *list, void *dataPtr);

bool listInsert(OrderedUniqueList *list, void *data);

bool listSearch(OrderedUniqueList *list, Deferable *data, int *index);

Deferable *listFind(OrderedUniqueList *list, Deferable *data);
